#ifndef QPID_FRAMING_MESSAGEREJECTBODY_H
#define QPID_FRAMING_MESSAGEREJECTBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"
#include "qpid/framing/ModelMethod.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class MessageRejectBody : public ModelMethod {
    SequenceSet transfers;
    uint16_t code;
    string text;
    uint16_t flags;
public:
    static const ClassId CLASS_ID = 0x4;
    static const MethodId METHOD_ID = 0x3;
    MessageRejectBody(
        ProtocolVersion, const SequenceSet& _transfers,
        uint16_t _code,
        const string& _text) : 
        transfers(_transfers),
        code(_code),
        text(_text),
        flags(0){
        flags |= (1 << 8);
        flags |= (1 << 9);
        flags |= (1 << 10);
    }
    MessageRejectBody(ProtocolVersion=ProtocolVersion())  : code(0), flags(0) {}
    
    void setTransfers(const SequenceSet& _transfers);
    const SequenceSet& getTransfers() const;
    bool hasTransfers() const;
    void clearTransfersFlag();
    void setCode(uint16_t _code);
    uint16_t getCode() const;
    bool hasCode() const;
    void clearCodeFlag();
    void setText(const string& _text);
    const string& getText() const;
    bool hasText() const;
    void clearTextFlag();
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.reject(getTransfers(), getCode(), getText());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }
    boost::intrusive_ptr<AMQBody> clone() const { return BodyFactory::copy(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t encodedSize() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class MessageRejectBody */

}}
#endif  /*!QPID_FRAMING_MESSAGEREJECTBODY_H*/
